package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.QMSFeign;
import com.steerinfo.dil.feign.QmsTruckFeign;
import com.steerinfo.dil.feign.WMSFeign;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.awt.image.Kernel;
import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author luobang
 * @create 2021-09-17 14:09
 */
@RestController
@RequestMapping("${api.version}/wms")
public class WMSController extends BaseRESTfulController {
    @Autowired
    WMSFeign wmsFeign;
    @Autowired
    QMSFeign qmsFeign;
    @PostMapping("getWmsInboundResult")
    @ApiOperation(value = "展示入库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "371", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmsInboundResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                                   Integer apiId,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                   Integer warehouseId,
                                                   String startTime,
                                                   String endTime) {
        return wmsFeign.getWmsInboundResult(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,warehouseId,startTime,endTime);
    }
    @PostMapping("getWmsInboundResultStatistics")
    @ApiOperation(value = "展示入库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "445", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmsInboundResultStatistics(@RequestBody(required = false) Map<String, Object> mapValue,
                                                   Integer apiId,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                   Integer warehouseId,
                                                   String startTime,
                                                   String endTime) {
        return wmsFeign.getWmsInboundResultStatistics(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,warehouseId,startTime,endTime);
    }
    @PostMapping("getWmsInboundResults")
    @ApiOperation(value = "展示入库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "371", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmsInboundResults(@RequestBody(required = false) Map<String, Object> mapValue,
                                                   Integer apiId,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                   Integer warehouseId,
                                                   String startTime,
                                                   String endTime) {
        return wmsFeign.getWmsInboundResults(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,warehouseId,startTime,endTime);
    }
    @PostMapping("getWmsReservedResult")
    @ApiOperation(value = "展示预留入库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "371", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmsReservedResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                                   Integer apiId,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                    Integer warehouseId,
                                                    String con) {
        return wmsFeign.getWmsReservedResult(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,warehouseId,con);
    }
    @PostMapping("getWmspOutboundResult")
    @ApiOperation(value = "展示出库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "152", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmspOutboundResult(@RequestBody(required = false) Map<String,Object> map,
                                                     Integer pageNum,
                                                     Integer pageSize,
                                                     Integer apiId,
                                                     Integer warehouseId,
                                                     String startTime,
                                                     String endTime) {
        return wmsFeign.getWmspOutboundResult(map==null?new HashMap<>():map,apiId, pageNum, pageSize,warehouseId,startTime,endTime);
    }

    @PostMapping("/wmspoutboundresults/insertWmspOutBoundResult")
    @ApiOperation(value = "新增出单实绩并返回出库单详情")
    public Map<String, Object> insertWmspOutBoundResult(@RequestBody(required = false) Map<String, Object> mapval) {
        Map<String, Object> resTfulResult = wmsFeign.insertWmspOutBoundResult(mapval);
        return resTfulResult;
    }

    @PostMapping(value = "/deletewmspOutboundResult")
    public Map<String,Object> deleteWmspOutboundResult(@RequestParam Integer resultId){
        return wmsFeign.deleteWmspOutboundResult(resultId);
    }

    @PostMapping("/wmspoutboundresults/insertwmspOutboundScanResult")
    public Map<String, Object> insertwmspOutboundScanResult(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.insertwmspOutboundScanResult(map);
        return resTfulResult;
    }

    @PostMapping("/wmspoutboundresults/outbountResultToSuccess")
    public Map<String,Object> outbountResultToSuccess(@RequestParam Integer resultId){
        return wmsFeign.outbountResultToSuccess(resultId);
    }

    @PostMapping("/updataResultStatus")
    public Map<String, Object> updataResultStatus(@RequestParam Integer resultId) {
        Map<String, Object> resTfulResult = wmsFeign.updataResultStatus(resultId);
        return resTfulResult;
    }

    @PostMapping("/getRmsMaterial")
    public Map<String, Object> getRmsMaterial(@RequestBody(required = false) Map<String, Object> mapval) {
        Map<String, Object> resTfulResult = wmsFeign.getRmsMaterial(mapval);
        return resTfulResult;
    }

    //查询实时库存数据
    @PostMapping("/selectGridMaterialList")
    @ApiOperation(value = "展示实时库存数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "167", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> selectGridMaterialList(@RequestBody(required = false) Map<String, Object> mapVal,
                                                      Integer pageNum,
                                                      Integer pageSize,
                                                      Integer apiId,
                                                      String warehouseId,
                                                      String time,
                                                      String con) {
        return wmsFeign.selectGridMaterialList(mapVal==null?new HashMap<>():mapVal,apiId, pageNum, pageSize,warehouseId,time,con);

    }
//    查询仓库中超过库龄预警的物资
    @PostMapping("/getGridMaterialAgeList")
    @ApiOperation(value = "查询仓库中超过库龄预警的物资")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "167", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getGridMaterialAgeList(@RequestBody(required = false) Map<String, Object> mapVal,
                                                      Integer warehouseId) {
        return wmsFeign.getGridMaterialAgeList(mapVal==null?new HashMap<>():mapVal,warehouseId);

    }

    //通过成品仓库网格ID查询实时库存数据
    @PostMapping("/selectGridMaterialListByGridId")
    @ApiOperation(value = "通过成品仓库网格ID展示实时库存数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "155", required = false, dataType = "BigDecimal"),
    })
    public Map<String,Object> selectGridMaterialListByGridId(BigDecimal gridId) {
        return wmsFeign.selectGridMaterialListByGridId(gridId);

    }

    //修改物资钢材表的质量是否合格字段和逻辑删除
    @PostMapping(value = "/updateRmsMaterialSteelDemotion")
    public Map<String,Object> updateRmsMaterialSteelDemotion(@RequestBody Map<String,Object> map){
        return wmsFeign.updateRmsMaterialSteelDemotion(map);
    }

    //钢材异地库出库扫描
    @PostMapping("/OutScanResultTag")
    public Map<String, Object> OutScanResultTag(@RequestBody(required = false) Map<String, Object> mapval) {
        Map<String, Object> resTfulResult = wmsFeign.OutScanResultTag(mapval);
        return resTfulResult;
    }

    //钢材异地库出库展示实绩
    @PostMapping("/getWmsOffsiteLibaryOutboundList")
    @ApiOperation(value = "展示实时库存数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "164", required = false, dataType = "BigDecimal"),
    })
    public Map<String, Object> getWmsOffsiteLibaryOutboundList(@RequestBody(required = false) Map<String, Object> mapVal,
                                                               Integer pageNum,
                                                               Integer pageSize,
                                                               Integer apiId,
                                                               String con) {
        return wmsFeign.getWmsOffsiteLibaryOutboundList(mapVal == null ? new HashMap<>() : mapVal, pageNum, pageSize, apiId, con);
    }

    //展示钢材扫描入库实绩列表
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "165", required = false, dataType = "BigDecimal"),
    })
    @PostMapping("/getWmsOffsiteLibaryInboundList")
    public Map<String, Object> getWmsOffsiteLibaryInboundList(@RequestBody(required = false) Map<String, Object> map,
                                                              Integer pageNum,
                                                              Integer pageSize,
                                                              Integer apiId,
                                                              String con) {
        return wmsFeign.getWmsOffsiteLibaryInboundList(map == null ? new HashMap<>() : map, pageNum, pageSize, apiId, con);
    }

    //钢材异地库扫描入库
    @PostMapping("/ScanResultTag")
    public Map<String, Object> insertOffsiteLibraryInbound(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.insertOffsiteLibraryInbound(map);
        return resTfulResult;
    }
    //获取扫描实绩
    @PostMapping("/getScanResult")
    public Map<String, Object> getScanResult(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.getScanResult(map);
        return resTfulResult;
    }
    //获取已下发的钢材的每个炉号的数量
    @PostMapping("/getFurnaceNoAmount")
    public Map<String, Object> getFurnaceNoAmount(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.getFurnaceNoAmount(map);
        return resTfulResult;
    }
    //更新状态
    @PostMapping("/updateStatus")
    public Map<String, Object> updateStatus(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.updateStatus(map);
        return resTfulResult;
    }

    //展示在途库存数据
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "153", required = false, dataType = "BigDecimal"),
    })
    @PostMapping("/getWmspIntransitInventory")
    public Map<String, Object> getWmspIntransitInventory(@RequestBody(required = false) Map<String, Object> mapVal,
                                                         Integer pageNum,
                                                         Integer pageSize,
                                                         Integer apiId,
                                                         String con) {
        return wmsFeign.getWmspIntransitInventory(mapVal == null?new HashMap<>():mapVal,apiId, pageNum, pageSize,con);
    }

    //新增倒库出库实绩
    @PostMapping("/insertOutBoundResult")
    public Map<String, Object> insertOutBoundResult(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.insertOutBoundResult(map);
        return resTfulResult;
    }

    //新增倒库出库扫描实绩
    @PostMapping("/AddWmspOutboundScanResult")
    public Map<String, Object> AddWmspOutboundScanResult(@RequestBody(required = false) Map<String, Object> mapVal) {
        Map<String, Object> resTfulResult = wmsFeign.AddWmspOutboundScanResult(mapVal);
        return resTfulResult;
    }

    //通过下拉框筛选数据
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "153", required = false, dataType = "BigDecimal"),
    })
    @PostMapping("/getWmspRestackMakeResultList")
    public Map<String, Object> getWmspRestackMakeResultList(@RequestBody(required = false) Map<String, Object> mapVal,
                                                            Integer pageNum,
                                                            Integer pageSize,
                                                            Integer apiId,
                                                            Integer warehouseid,
                                                            Integer stackingId,
                                                            Integer gradtionNumber) {
        return wmsFeign.getWmspRestackMakeResultList(mapVal==null?new HashMap<>():mapVal,apiId, pageNum, pageSize, warehouseid, stackingId, gradtionNumber);
    }


    @PostMapping(value = "/addRestackMakeResult")
    public Map<String,Object> addRestackMakeResult(@RequestBody  Map<String,Object> mapval){
        return wmsFeign.addRestackMakeResult(mapval);
    }

    //删除倒垛单
    @PostMapping("/deleteByResultId/{resultId}")
    public Map<String, Object> deleteByResultId(@PathVariable String resultId) {
        Map<String, Object> resTfulResult = wmsFeign.deleteByResultId(resultId);
        return resTfulResult;
    }

    //下发倒垛单
    @PostMapping("/dispatchDistrubtionStatus/{resultId}")
    public Map<String, Object> dispatchDistrubtionStatus(@PathVariable String resultId) {
        Map<String, Object> resTfulResult = wmsFeign.dispatchDistrubtionStatus(resultId);
        return resTfulResult;
    }

    //下拉框获取层次
    @GetMapping("/selectGardationNumber")
    public Map<String, Object> selectGardationNumber(Integer warehouseid, Integer stackingId) {
        Map<String, Object> resTfulResult = wmsFeign.selectGardationNumber(warehouseid, stackingId);
        return resTfulResult;
    }

    //下拉框获取仓库名称
    @GetMapping("/selectWarehouse")
    public Map<String, Object> selectWarehouse() {
        Map<String, Object> resTfulResult = wmsFeign.selectWarehouse();
        return resTfulResult;
    }

    //下拉框获取仓库名称
    @GetMapping("/selectStackingId")
    public Map<String, Object> selectStackingId(Integer warehouseid) {
        Map<String, Object> resTfulResult = wmsFeign.selectStackingId(warehouseid);
        return resTfulResult;
    }

    //展示倒垛单
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "119", required = false, dataType = "BigDecimal"),
    })
    @PostMapping("/selectRestackList")
    public Map<String, Object> selectRestackList(@RequestBody(required = false) Map<String, Object> mapVal,
                                                 Integer pageNum,
                                                 Integer pageSize,
                                                 Integer apiId,
                                                 Integer DistrubtionStatus) {
        return wmsFeign.selectRestackList(mapVal==null?new HashMap<>():mapVal,apiId, pageNum, pageSize, DistrubtionStatus);
    }
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "119", required = false, dataType = "BigDecimal"),
    })
    @PostMapping("/selectRestackList2")
    public Map<String, Object> selectRestackList2(@RequestBody(required = false) Map<String, Object> mapVal,
                                                 Integer pageNum,
                                                 Integer pageSize,
                                                 Integer apiId,
                                                 Integer DistrubtionStatus) {
        return wmsFeign.selectRestackList2(mapVal==null?new HashMap<>():mapVal,apiId, pageNum, pageSize, DistrubtionStatus);
    }

    @PostMapping("/editRestackMakeResult")
    public Map<String, Object> editRestackMakeResult(@RequestBody(required = false) Map<String, Object> mapVal) {
        Map<String, Object> resTfulResult = wmsFeign.editRestackMakeResult(mapVal);

        return resTfulResult;
    }

    //渲染倒垛后的仓库信息
    @PostMapping("/selectAfterWarehouseByResultId/{resultId}")
    public Map<String, Object> selectAfterWarehouseByResultId(@PathVariable Integer resultId) {
        Map<String, Object> resTfulResult = wmsFeign.selectAfterWarehouseByResultId(resultId);
        return resTfulResult;
    }

    //渲染倒垛后的垛位信息
    @PostMapping("/selectAfterstackingByResultId/{resultId}")
    public Map<String, Object> selectAfterstackingByResultId(@PathVariable Integer resultId) {
        Map<String, Object> resTfulResult = wmsFeign.selectAfterWarehouseByResultId(resultId);
        return resTfulResult;
    }

    //PDA展示倒垛单
    @PostMapping("/selectRestackForPDA")
    public Map<String, Object> selectRestackForPDA(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.selectRestackForPDA(map);
        return resTfulResult;
    }

    //PDA根据实绩id查找物资信息
    @PostMapping("/selectMaterialInfoByResultId")
    public Map<String, Object> selectMaterialInfoByResultId(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.selectMaterialInfoByResultId(map);
        return resTfulResult;
    }


   @ApiImplicitParams({
           @ApiImplicitParam(value = "395",name = "apiId")
   })
    @PostMapping(value = "/getRestackInfoByResultId")
    public RESTfulResult getRestackInfoByResultId(@RequestBody(required = false) Map<String,Object> mapVal,
                                                  Integer pageNum,
                                                  Integer pageSize,
                                                  Integer apiId

    ){
        return  wmsFeign.getRestackInfoByResultId(mapVal==null?new HashMap<>():mapVal, pageNum, pageSize, apiId);
    }

    //PDA根据仓库id查找倒垛单
    @PostMapping("/selectRestackByWarehouseId")
    public Map<String, Object> selectRestackByWarehouseId(@RequestBody(required = false) Map<String, Object> map) {
        Map<String, Object> resTfulResult = wmsFeign.selectRestackByWarehouseId(map);
        return resTfulResult;
    }

    //扫描吊牌添加扫描实绩
    @PostMapping("/ScanTagResult")
    public Map<String, Object> ScanTagResult(@RequestBody(required = false) Map<String, Object> mal) {
        Map<String, Object> resTfulResult = wmsFeign.ScanTagResult(mal);
        return resTfulResult;
    }

    //下发
    @PostMapping("/Issue")
    public Map<String, Object> Issue(@RequestBody(required = false) List<Map<String, Object>> mapList) {
        Map<String, Object> resTfulResult = wmsFeign.Issue(mapList);
        return resTfulResult;
    }

    /**
     * 2.展示退库实绩信息
     *
     * @param mapValue
     * @param apiId
     * @param pageNum
     * @param pageSize
     * @return
     */
    @PostMapping("/getWmsReboundResult")
    @ApiOperation(value = "展示退库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "161", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getWmsReboundResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                             Integer apiId,
                                             Integer pageNum,
                                             Integer pageSize,
                                             String con) {
        return wmsFeign.getWmsReboundResult(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,con);
    }

    @PostMapping("/selectScanResultByIboundResultId")
    @ApiOperation(value = "根据入库实绩id获得扫描实绩数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult selectScanResultByIboundResultId(@RequestBody(required = false) Map<String, Object> mapValue,
                                                          @RequestParam Integer apiId,
                                                          @RequestParam Integer pageNum,
                                                          @RequestParam Integer pageSize,
                                                          @RequestParam Integer inboundId
    ) {
        return wmsFeign.selectScanResultByIboundResultId(mapValue==null?new HashMap<>():mapValue, apiId,pageNum, pageSize,inboundId);
    }
    //根据物资信息获取原来垛位信息
    @PostMapping("/selectInfoByMaterialCode")
    public Map<String, Object> selectInfoByMaterialCode(@RequestBody(required = false) Map<String, Object> mal) {
        if (mal == null) {
            mal = new HashMap<>();
        }
        return  wmsFeign.selectInfoByMaterialCode(mal);
    }
    //根据仓库查询未接收的垛位
    @PostMapping("/selectStackingInfoByWarehouseId")
    public Map<String, Object> selectStackingInfoByWarehouseId(@RequestBody(required = false) Map<String, Object> mal) {
        if (mal == null) {
            mal = new HashMap<>();
        }
        return  wmsFeign.selectStackingInfoByWarehouseId(mal);
    }

    @PostMapping("/getWmsIvboundResult")
    @ApiOperation(value = "展示倒库实绩信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "162", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getWmsIvboundResult(@RequestBody(required = false) Map<String, Object> mapValue,
                                             Integer apiId,
                                             Integer pageNum,
                                             Integer pageSize) {
        return wmsFeign.getWmsIvboundResult(mapValue, apiId, pageNum, pageSize);
    }


    /**
     * 展示倒库物资实绩
     *
     * @param mapValue
     * @param apiId
     * @param pageNum
     * @param pageSize
     * @return
     */
    @PostMapping("/getWmsIvboundMaterialt")
    @ApiOperation(value = "展示倒库物资实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "163", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getWmsIvboundMaterial(@RequestBody(required = false) Map<String, Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize) {
        return wmsFeign.getWmsIvboundMaterial(mapValue, apiId, pageNum, pageSize);
    }

    @PostMapping("/getInventoryCheck")
    @ApiOperation(value = "展示库存盘点实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "94", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getInventoryCheck(@RequestBody(required = false) Map<String, Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize,
                                           String  con) {
        return wmsFeign.getInventoryCheck(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,con);
    }

    @PostMapping("/getInventoryClose")
    @ApiOperation(value = "展示库存结转实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "95", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getInventoryClose(@RequestBody(required = false) Map<String, Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize,
                                           String  value) {
        return wmsFeign.getInventoryClose(mapValue == null?new HashMap<>():mapValue, apiId, pageNum, pageSize,value);
    }
    //库存结转定时器
    @PostMapping("/addInventoryClose")
    @ApiOperation(value = "库存结转定时器")
    public RESTfulResult addInventoryClose(){
        return wmsFeign.addInventoryClose();
    }

    @PostMapping("/getSendReceive")
    @ApiOperation(value = "展示收发存实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "97", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getSendReceive(@RequestBody(required = false) Map<String, Object> mapValue,
                                        Integer apiId,
                                        Integer pageNum,
                                        Integer pageSize,
                                        String con,
                                        String startTime,
                                        String endTime) {
        return wmsFeign.getSendReceive(mapValue ==null? new HashMap<>():mapValue, apiId, pageNum, pageSize,con,startTime,endTime);
    }

    /**
     * 展示未下发吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示未下发吊钢工扫描吊牌实绩")
    @PostMapping("/getTagResult")
    public Map<String, Object> getTagResult() {
        return wmsFeign.getTagResult();
    }

    /**
     * 展示正常入库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示正常入库吊钢工扫描吊牌实绩")
    @PostMapping("/getIssuedTagResult")
    public Map getIssuedTagResult() {
        return wmsFeign.getIssuedTagResult();
    }

    /**
     * 展示异常入库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示异常入库吊钢工扫描吊牌实绩")
    @PostMapping("/getIssuedTagNoResult")
    public Map getIssuedTagNoResult() {
        return wmsFeign.getIssuedTagNoResult();
    }

    /**
     * 展示已退库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示已退库吊钢工扫描吊牌实绩")
    @PostMapping("/getReIssuedResult")
    public Map getReIssuedResult() {
        return wmsFeign.getIssuedResult();
    }

    /**
     * 展示未下发退库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示未下发退库吊钢工扫描吊牌实绩")
    @PostMapping("/getReTagResult")
    public Map getReTagResult() {
        return wmsFeign.getReTagResult();
    }

    /**
     * 展示已倒库入库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示已倒库入库吊钢工扫描吊牌实绩")
    @PostMapping("/getIvIssuedResult")
    public Map getIvIssuedResult() {
        return wmsFeign.getIvIssuedResult();
    }

    /**
     * 展示未下发退库吊钢工扫描吊牌实绩
     *
     * @return
     */
    @ApiOperation(value = "展示未下发退库吊钢工扫描吊牌实绩")
    @PostMapping("/getIvTagResult")
    public Map getIvTagResult() {
        return wmsFeign.getIvTagResult();
    }

    /**
     * 新增入库实绩
     *
     * @param mapList
     * @return
     */
    @ApiOperation("新增入库实绩")
    @PostMapping("/insertInboundResult")
    @Transactional
    public Map<String,Object> addInvoice(@RequestBody(required = false) List<Map<String, Object>> mapList) {
        return wmsFeign.insertInboundResult(mapList);
    }

    /**
     * 新增退库实绩
     *
     * @param mapList
     * @return
     */
    @ApiOperation("新增退库实绩")
    @PostMapping("/insertReboundResult")
    @Transactional
    public String addReboundResult(@RequestBody(required = false) List<Map<String, Object>> mapList) {
        /*
        获取入库物资件数
         */
        int size = mapList.size();
        /*
        获取入库垛位
         */
        Map<String, Object> map1 = qmsFeign.getStackingId(new BigDecimal(1), size);
        String stackNo = (String) map1.get("stackNo");
        BigDecimal stackId = new BigDecimal(map1.get("stackId").toString());
        for (Map<String, Object> map : mapList
        ) {
            map.put("stackingId", stackId);
        }
        wmsFeign.insertReboundResult(mapList);
        return stackNo;
    }

    /**
     * 新增倒库入库实绩
     *
     * @param mapList
     * @return
     */
    @ApiOperation("新增倒库入库实绩")
    @PostMapping("/insertIvboundResult")
    @Transactional
    public String addIvboundResult(@RequestBody(required = false) List<Map<String, Object>> mapList) {
        /*
        获取入库物资件数
         */
        int size = mapList.size();
        /*
        获取入库垛位
         */
        Map<String, Object> map1 = qmsFeign.getStackingId(new BigDecimal(1), size);
        String stackNo = (String) map1.get("stackNo");
        BigDecimal stackId = new BigDecimal(map1.get("stackId").toString());
        for (Map<String, Object> map : mapList
        ) {
            map.put("stackingId", stackId);
        }
        wmsFeign.insertIvboundResult(mapList);
        return stackNo;
    }

    /**
     * 展示入库垛位
     *
     * @param DriverId
     * @return
     */
    @PostMapping("/getInboundStack")
    @ApiOperation(value = "展示入库垛位")
    public Integer getInboundStack(Integer DriverId) {
        return wmsFeign.getInboundStack(DriverId);
    }

    /**
     * 新增库存盘点
     *
     * @param map
     * @return
     */
    @PostMapping("/inventoryCheck")
    @ApiOperation(value = "新增库存盘点")
    public Map<String, Object> inventoryCheck(@RequestBody(required = false) Map<String, Object> map) {
        return wmsFeign.inventoryCheck(map);
    }

    /**
     * 新增入库扫描吊牌实绩
     *
     * @param map
     * @return
     */
    @ApiOperation(value = "新增入库扫描吊牌实绩")
    @PostMapping("/inboundScanResult/insertResult")
    @Transactional
    public Map<String, Object> insertResult(@RequestBody(required = false) Map<String, Object> map) {
        return wmsFeign.insertResult(map);
    }

    /**
     * 新增退库扫描吊牌实绩
     *
     * @param map
     * @return
     */
    @ApiOperation(value = "新增退库扫描吊牌实绩")
    @PostMapping("/insertReboundScanResult")
    @Transactional
    public Map<String, Object> insertReboundScanResult(@RequestBody(required = false) Map<String, Object> map) {
        return wmsFeign.insertReboundScanResult(map);
    }

    /**
     * 新增倒库入库扫描吊牌实绩
     *
     * @param map
     * @return
     */
    @ApiOperation(value = "新增倒库入库扫描吊牌实绩")
    @PostMapping("/insertIvboundScanResult")
    @Transactional
    public Map<String, Object> insertIvboundScanResult(@RequestBody(required = false) Map<String, Object> map) {
        return wmsFeign.insertIvboundScanResult(map);
    }

    /**
     * 根据实绩id查找物资唯一编码是否已经稽核完成
     */
    @PostMapping("/selectMaterialSteelIdByReusltId")
    @Transactional
    public Map<String, Object> selectMaterialSteelIdByReusltId(@RequestBody(required = false) Map<String, Object> map) {
        return wmsFeign.selectMaterialSteelIdByReusltId(map);
    }

    //下发指令给行车工
    @PostMapping("/updateInstruction")
    public Map<String, Object> updateInstruction(@RequestBody Map<String, Object> map) {
        return wmsFeign.updateInstruction(map);
    }



    @PostMapping("/getIvboundMakeResultList")
    @ApiOperation(value = "展示倒库列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "372", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getIvboundMakeResultList(@RequestBody(required = false) Map<String, Object> mapValue,
                                                          Integer pageNum,
                                                          Integer pageSize,
                                                          Integer apiId,
                                                          String con) {

        if (mapValue == null) {
            mapValue = new HashMap<>();
        }
        return wmsFeign.getIvboundMakeResultList(mapValue, pageNum, pageSize, apiId, con);
    }

    /**
     * 新增倒库作业
     * @param mapValue
     * @return
     */
    @PostMapping(value = "/addIvboundMakeResult")
    public Map<String,Object> addIvboundMakeResult(@RequestBody Map<String,Object> mapValue) {
        return wmsFeign.addIvboundMakeResult(mapValue);
    }

    /**
     * 逻辑删除倒库作业
     * @param resultId
     * @return
     */
    @PostMapping(value = "/deleteIvboundMakeResult/{resultId}")
    public Map<String,Object> deleteIvboundMakeResult(@PathVariable("resultId") Integer resultId) {
        return wmsFeign.deleteIvboundMakeResult(resultId);
    }

    /**
     * 查询倒库作业
     * @param resultId
     * @return
     */
    @PostMapping(value = "/selectIvboundMakeResult/{resultId}")
    public List<Map<String,Object>> selectIvboundMakeResult(@PathVariable("resultId") Integer resultId) {
        return wmsFeign.selectIvboundMakeResult(resultId);
    }

    /**
     * 修改倒库作业
     * @param mapValue
     * @return
     */
    @PostMapping(value = "/updateIvboundMakeResult")
    public Map<String,Object> updateIvboundMakeResult(@RequestBody Map<String,Object> mapValue) {
        return wmsFeign.updateIvboundMakeResult(mapValue);
    }
    //下发给行车工
    @PostMapping("/IssueToCrane")
    Map<String,Object> IssueToCrane(@RequestBody Map<String, Object> map){
        return wmsFeign.IssueToCrane(map);
    }
    //新增入库实绩
    @PostMapping("/inboundResult/insertInboundResult")
    public  RESTfulResult addInvoice(@RequestParam("userName") String userName,@RequestParam("groupId") BigDecimal groupId,@RequestParam("personnelWorkshopid") BigDecimal personnelWorkshopid, @RequestBody(required = false) List<Map<String, Object>> mapList){


        return wmsFeign.addInvoice(userName,groupId,personnelWorkshopid,mapList);
    }
    //抢单
    @PostMapping("/wmspinbounddistributes/grabDistribute")
    public  RESTfulResult grabDistribute( @RequestBody Map<String,Object> mapValue){
        return wmsFeign.grabDistribute(mapValue);
    }

    @GetMapping("/wmspinbounddistributes/getNewDistribute")
    public  RESTfulResult getNewDistribute( @RequestParam("personnelWorkshopid") Integer personnelWorkshopid){
        return wmsFeign.getNewDistribute(personnelWorkshopid);
    }


//    @PostMapping("/createRestackMakeResult")
//    public  RESTfulResult createRestackMakeResult(@RequestParam("keeperId") BigDecimal keeperId,
//                                                  @RequestParam("beforeLevel")BigDecimal  beforeLevel,
//                                                  @RequestParam(name = "afterStackingId",defaultValue = "20")BigDecimal afterStackingId,
//                                                  @RequestParam("afterWarehouseId")BigDecimal afterWarehouseId,
//                                                  @RequestParam("afterBeforeStackingId") BigDecimal afterBeforeStackingId,
//                                                  @RequestParam("resultRemark")String resultRemark,
//                                                  @RequestBody(required = false) List<Map<String,Object>> mps){
//        return wmsFeign.createRestackMakeResult(keeperId,beforeLevel,afterStackingId,afterWarehouseId,afterBeforeStackingId,resultRemark,mps);
//    }




        //    获取物资类型
        @PostMapping(value = "/getMaterialTypeList")
        public Map<String, Object> getMaterialTypeList (@RequestParam("warehouseid") String warehouseid,
                @RequestParam("stackingId") BigDecimal stackingId,
                @RequestParam("gradtionNumber") BigDecimal gradtionNumber,
                @RequestParam("pageNum") Integer pageNum,
                @RequestParam("pageSize") Integer pageSize,
                @RequestParam("apiId") Integer apiId){
            return wmsFeign.getMaterialTypeList(warehouseid, stackingId, gradtionNumber, pageNum, pageSize, apiId);
        }


    @ApiOperation("进入出库扫码页面，查询出库物资信息详情")
    @GetMapping("/wmspoutboundresults/getInitOutboundScanResultMaterialInfo")
    @ApiImplicitParam(name = "resultId",value = "出库实绩id",paramType = "BigDecimal",required = true)
    public RESTfulResult getInitOutboundScanResultMaterialInfo(@RequestParam(value = "resultId",required = true) BigDecimal resultId){
        return wmsFeign.getInitOutboundScanResultMaterialInfo(resultId);
    }

    @PostMapping("/wmspoutboundresults/deleteGridMaterial")
    public RESTfulResult deleteGridMaterial(@RequestParam String materialOnlyCode){
        return wmsFeign.deleteGridMaterial(materialOnlyCode);
    }

    @PostMapping(value = "/createRestackMakeResult")
    public Map<String, Object> createRestackMakeResult (@RequestParam("keeperId") BigDecimal keeperId,
                                                        @RequestParam("beforeLevel") BigDecimal beforeLevel,
                                                        @RequestParam(name = "afterStackingId", defaultValue = "20") BigDecimal afterStackingId,
                                                        @RequestParam("afterWarehouseId") BigDecimal afterWarehouseId,
                                                        @RequestParam("afterBeforeStackingId") BigDecimal afterBeforeStackingId,
                                                        @RequestParam("resultRemark") String resultRemark,
                                                        @RequestBody(required = false) List < Map < String, Object >> mps){
        return wmsFeign.createRestackMakeResult(keeperId, beforeLevel, afterStackingId, afterWarehouseId, afterBeforeStackingId, resultRemark, mps);
    }

    //修改实时库存,针对倒垛
    @PostMapping(value = "/updateWmspGridMaterialForRestack")
    public Map<String, Object> updateWmspGridMaterialForRestack (@RequestBody Map < String, Object > mapValue){
        return wmsFeign.updateWmspGridMaterialForRestack(mapValue);
    }


    //修改实时库存,针对倒垛
    @PostMapping(value = "/getStockTakingList")
    public Map<String, Object> getStockTakingList (@RequestParam(value = "pageNum") Integer pageNum,
                                                   @RequestParam(value = "pageSize") Integer pageSize,
                                                   @RequestParam(value = "apiId") Integer apiId){
        return wmsFeign.getStockTakingList(pageNum, pageSize, apiId);
    }
    //    根据倒垛单ID获得物资类型
    @GetMapping(value = "getRestackMakeTypeResult")
    public Map<String, Object> getRestackMakeTypeResult (@RequestParam("restackMake") String restackMake,
                                                         @RequestParam("context") String context){
        return wmsFeign.getRestackMakeTypeResult(restackMake, context);
    }
    //    改变已经稽核的吊牌信息
    @GetMapping(value = "changeRestackMakeResult")
    public int changeRestackMakeResult (@RequestParam("restackMake") String restackMake){
        return wmsFeign.changeRestackMakeResult(restackMake);

    }

    //PDA根据仓库id查找倒垛单
    @GetMapping(value = "selectRestackByWarehouseIds")
    public Map<String, Object> selectRestackByWarehouseIds(@RequestParam("warehouseid") String warehouseid) {
        return wmsFeign.selectRestackByWarehouseIds(warehouseid);
    }

    //修改实时库存,针对倒垛
    @PostMapping(value = "/insertStockTaking")
    public Map<String,Object> insertStockTaking(@RequestParam(value = "warehouseId") String warehouseId,
                                                @RequestParam(value = "materialCode") String materialCode,
                                                @RequestParam(value = "quantity") Integer quantity) {
        return wmsFeign.insertStockTaking(warehouseId,materialCode,quantity);
    }
    //修改入库转预留作业,针对预留
    @PostMapping(value = "/insertReserved")
    public Map<String,Object> insertReserved(@RequestParam(value = "warehouseId") String warehouseId,
                                             @RequestParam(value = "materialCode") String materialCode,
                                             @RequestParam(value = "materialSpecification") String materialSpecification,
                                             @RequestParam(value = "materialModel") String materialModel,
                                             @RequestParam(value = "quantity") Integer quantity) {
        return wmsFeign.insertReserved(warehouseId,materialCode,materialSpecification,materialModel,quantity);
    }
    //修改预留转入库作业,针对预留
    @PostMapping(value = "/insertInbounds")
    public Map<String,Object> insertInbounds(@RequestParam(value = "warehouseId") String warehouseId,
                                             @RequestParam(value = "materialCode") String materialCode,
                                             @RequestParam(value = "materialSpecification") String materialSpecification,
                                             @RequestParam(value = "materialModel") String materialModel,
                                             @RequestParam(value = "quantity") Integer quantity) {
        return wmsFeign.insertInbounds(warehouseId,materialCode,materialSpecification,materialModel,quantity);
    }
//    查询所有的钢材物资信息
    @PostMapping(value = "/getSteelMaterialList")
    public Map<String,Object> getSteelMaterialList(@RequestBody(required = false) Map<String,Object> mapVal,
                                                  Integer pageNum,
                                                  Integer pageSize,
                                                  Integer apiId,
                                                  Integer warehouseId,
                                                   String con) {
        return wmsFeign.getSteelMaterialList(mapVal ==null? new HashMap<>():mapVal,pageNum,pageSize,apiId,warehouseId,con);
    }
    //    查询所有的钢材物资信息
    @PostMapping(value = "/getSteelWarehouseList")
    public Map<String,Object> getSteelWarehouseList(@RequestBody(required = false) Map<String,Object> mapVal,
                                                   Integer apiId,
                                                    Integer pageNum,
                                                    Integer pageSize,
                                                   String con) {
        return wmsFeign.getSteelWarehouseList(mapVal ==null? new HashMap<>():mapVal,apiId,pageNum,pageSize,con);
    }
    //    查询所有的钢材物资规格型号信息
    @PostMapping(value = "/getSteelMaterialModelList")
    public Map<String,Object> getSteelMaterialModelList(@RequestBody(required = false) Map<String, Object> mapValue,
                                                        @RequestParam(value = "pageNum") Integer pageNum,
                                                        @RequestParam(value = "pageSize") Integer pageSize,
                                                        @RequestParam(value = "apiId") Integer apiId,
                                                        @RequestParam(value = "warehouseId") Integer warehouseId,
                                                        @RequestParam(value = "status") Integer status,
                                                        @RequestParam(value = "con") String con) {
        return wmsFeign.getSteelMaterialModelList(mapValue ==null? new HashMap<>():mapValue,pageNum,pageSize,apiId,warehouseId,status,con);
    }
//    根据对应的入库实绩id修改入库状态为预留
    @PostMapping("/changeReserved")
    @ApiOperation(value = "根据对应的入库实绩id修改入库状态为预留")
    public int changeReserved(@RequestBody(required = false) List<Map<String, Object>> mapList) {
        return wmsFeign.changeReserved(mapList);
    }

    @PostMapping("/getWmsOutboundResultStatistics")
    @ApiOperation(value = "展示炉号对应的出厂数量")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "446", required = false, dataType = "BigDecimal"),
    })
    public RESTfulResult getWmsOutboundResultStatistics(@RequestBody(required = false) Map<String, Object> mapValue,
                                        Integer apiId,
                                        Integer pageNum,
                                        Integer pageSize,
                                        Integer warehouseId,
                                        String con,
                                        String startTime,
                                        String endTime) {
        return wmsFeign.getWmsOutboundResultStatistics(mapValue ==null? new HashMap<>():mapValue, apiId, pageNum, pageSize,warehouseId,con,startTime,endTime);
    }

    //删除扫码吊牌
    @PostMapping("/undoInbound")
    @ApiOperation(value = "删除扫码吊牌")
    public Map<String, Object> undoInbound(@RequestParam("inboundId") BigDecimal inboundId){
        return wmsFeign.undoInbound(inboundId);
    }
}

